include <masze.scad>;

module base()
{
	color([0.8, 0.8, 0.8])
	translate([0, 0, cnc_feetheight])
	{
		cube([cnc_base_x, cnc_base_y, cnc_base_z]);
		translate([0, 0, cnc_base_z])
			cube([cnc_base_x + cnc_excess_xplus, cnc_xaxis_y, cnc_xaxis_z]);
		translate([0, cnc_base_y - cnc_xaxis_y, cnc_base_z])
			cube([cnc_base_x + cnc_excess_xplus, cnc_xaxis_y, cnc_xaxis_z]);
	}
}

module yaxis()
{
	color([0.6, 0.6, 0.6])
	translate([cnc_yaxis_xmin + cnc_yaxis_xpos * cnc_yaxis_xrange, -cnc_excess_yminus, cnc_base_z + cnc_feetheight])
		cube([cnc_yaxis_x, cnc_base_y + cnc_excess_yminus, cnc_yaxis_z]);
}

module zaxis()
{
	color([0.4, 0.4, 0.4])
	translate([cnc_yaxis_xmin + cnc_yaxis_xpos * cnc_yaxis_xrange, cnc_zaxis_ymin + cnc_zaxis_ypos * cnc_zaxis_yrange, cnc_base_z + cnc_feetheight + cnc_yaxis_z])
		cube([cnc_yaxis_x, cnc_zaxis_y, cnc_zaxis_z]);
}

module zsled()
{
	color([0.4, 0.4, 0.4])
	translate([cnc_yaxis_xmin + cnc_yaxis_xpos * cnc_yaxis_xrange - cnc_zsled_x, cnc_zaxis_ymin + cnc_zaxis_ypos * cnc_zaxis_yrange, cnc_zsled_zmin + cnc_zsled_zpos * cnc_zsled_range])
		cube([cnc_zsled_x, cnc_zaxis_y, cnc_zsled_z]);
}

module tool()
{
	color([0.1, 0.1, 0.8])
	translate([cnc_yaxis_xmin + cnc_yaxis_xpos * cnc_yaxis_xrange - cnc_zsled_x, cnc_zaxis_ymin + cnc_zaxis_ypos * cnc_zaxis_yrange, cnc_zsled_zmin + cnc_zsled_zpos * cnc_zsled_range])
	translate(cnc_zsled_to_mill)
		cylinder(r=tool_radius, h=tool_height);
}

module axis_bbox()
{
	render() union() {
		// y axis
		translate([cnc_yaxis_xmin, -cnc_excess_yminus, cnc_base_z + cnc_feetheight])
			cube([cnc_yaxis_x + cnc_yaxis_xrange, cnc_base_y + cnc_excess_yminus, cnc_yaxis_z]);
		// zsled plus z axis
		translate([cnc_yaxis_xmin - cnc_zsled_x, cnc_zaxis_ymin, cnc_base_z + cnc_feetheight])
			cube([cnc_zsled_x + cnc_yaxis_xrange + cnc_yaxis_x, cnc_zaxis_y + cnc_zaxis_yrange, cnc_zaxis_z + cnc_yaxis_z]);
	}
}

module feet()
{
	module singlefeet() {
		translate([cnc_feet_offsetx, cnc_feet_offsety1, 0]) cylinder(r=cnc_feet_r, h=cnc_feetheight, $fn=10);
		translate([cnc_feet_offsetx, cnc_feet_offsety2, 0]) cylinder(r=cnc_feet_r, h=cnc_feetheight, $fn=10);
	}
	module doublefeet() {
		singlefeet();
		translate([cnc_base_x, 0, 0]) mirror([1, 0, 0]) singlefeet();
	}
	doublefeet();
	translate([0, cnc_base_y, 0]) mirror([0, 1, 0]) doublefeet();
}

module cnc()
{
	base();
	yaxis();
	zaxis();
	zsled();
	tool();
	feet();

	% axis_bbox();
}
